#!/bin/bash
#
# inxworld-epg.sh - Extract EPG from www.inxworld.com to VDR
#                                                Version 1.0
# Created Sa Aug 12 03:34:09 CEST 2006
# by Thomas Creutz <thomas.creutz@gmx.de>
#
# This code is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This code is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# Or, point your browser to http://www.gnu.org/copyleft/gpl.html

# Dateien
XMLTV2VDR="/video/DVB/vdr/xmltv2vdr-1.0.6/xmltv2vdr.pl"
MODIFIED_CHANNELSCONF="/video/DVB/vdr/xmltv2vdr-1.0.6/inxworld.conf"
XML_FILE="/tmp/inxworld-epg.xml"
TMP_FILE="/tmp/inxworld-epg"

# Adressen
FREEX_TV_URL="tv_program.php%3Ftv%3D1%26prg%3D"
XDREAM_TV_URL="tv_program.php%3Ftv%3D2%26prg%3D"
FREEX_TV2_URL="tv_program.php%3Ftv%3D4%26prg%3D"

# Berechne Programmseite (Datum)
START_NR=955
START_DATE="20060812"
TIME_DIFF=$(($(date +%s)-$(date +%s --date $START_DATE)))
DAY_DIFF=$(($TIME_DIFF/86400))
PROG=$(($DAY_DIFF+$START_NR))

# Sonnstige Variablen
COUNT=0
declare -a array

# Schleife zum durchlaufen der 3 Sender
while [ "$COUNT" -lt "3" ]
do
	PROG_S=$PROG
	# Schleife zum Durchlaufen einer Woche
	while [ "$PROG_S" -lt "$(($PROG+7))" ]
	do
		case "$COUNT" in
			"0")
				wget --quiet --post-data "accord_enter=yes&click_img_zone=&choice_zone=2&where_i_go=${FREEX_TV_URL}${PROG_S}" http://www.inxworld.com/record_zone.php -O ${TMP_FILE}
				CHANNELNAME="FREEX-TV"
				;;
			"1")
				wget --quiet --post-data "accord_enter=yes&click_img_zone=&choice_zone=2&where_i_go=${XDREAM_TV_URL}${PROG_S}" http://www.inxworld.com/record_zone.php -O ${TMP_FILE}
				CHANNELNAME="XDREAM-TV"
				;;
			"2")
				wget --quiet --post-data "accord_enter=yes&click_img_zone=&choice_zone=2&where_i_go=${FREEX_TV2_URL}${PROG_S}" http://www.inxworld.com/record_zone.php -O ${TMP_FILE}
				CHANNELNAME="FREEX-TV2"
				;;
			*)
				echo "..."
				;;
		esac
		# Schleife zum einlesen der Datei
		while read line
		do
			if [ "$(echo "$line" | grep "TV PROGRAM" )" ]
			then
				DAY=$(echo "$line" | awk -F'face="Verdana">' '{print $3}' | cut -d' ' -f1 )
			fi

			if [ "$(echo "$line" | grep "<strong>" | grep -v "TV PROGRAM" )" ]
			then
				# Daten ermitteln
				TIME=$(echo "$line" | awk -Fstrong '{print $2}' | cut -d'>' -f2 | cut -d'<' -f1 )
				TITLE=$(echo "$line" | awk -F'<td width="340" bgcolor="#222222">' '{print $2}' | cut -d'<' -f1 )
				SECTION=$(echo "$line" | awk -F'alt="' '{print $2}' | cut -d'"' -f1 )
				LANGUAGE=$(echo "$line" | awk -F'<td width="80" bgcolor="#222222">' '{print $2}' | cut -d'<' -f1 )

				# ermittelte Werte ausgeben
				echo "$CHANNELNAME - $DAY - $TIME - $TITLE - $SECTION - $LANGUAGE"

				# Daten in Array Schreiben
				Z=${#array[*]}
				array[$Z]="$CHANNELNAME|$DAY|$TIME|$TITLE|$SECTION|$LANGUAGE"
				#echo "array[$Z]=${array[$Z]}"

			fi
		done < ${TMP_FILE}
		# nchster Tag
		PROG_S=$(($PROG_S+1))
	done
	# nchstes Programm...
	COUNT=$(($COUNT+1))
done

COUNT=0
echo "Erstelle XML-Datei..."

# Header in XML Datei schreiben
echo "<?xml version=\"1.0\" encoding=\"iso-8859-1\" ?>
<tv generator-info-name=\"inxworld-epg.sh\" generator-info-url=\"http://www.alientxc.de\">
<channel id=\"FREEX-TV\">
  <display-name lang=\"de\">FREEX-TV</display-name>
  <url>http://www.inxworld.com/${FREEX_TV_URL}</url>
</channel>
<channel id=\"XDREAM-TV\">
  <display-name lang=\"de\">XDREAM-TV</display-name>
  <url>http://www.inxworld.com/${XDREAM_TV_URL}</url>
</channel>
<channel id=\"FREEX-TV2\">
  <display-name lang=\"de\">FREEX-TV2</display-name>
  <url>http://www.inxworld.com/${FREEX_TV2_URL}</url>
</channel>" > $XML_FILE

while [ "$COUNT" -lt "${#array[*]}" ]
do
	# Zeitangaben Formatieren
	START="$(echo ${array[$COUNT]}|awk -F'|' '{print $2}'|sed 's/-//g')$(echo ${array[$COUNT]}|awk -F'|' '{print $3}'|sed 's/://g')00"
	if [ "$(echo ${array[$COUNT]}|awk -F'|' '{print $1}')" = "$(echo ${array[$(($COUNT+1))]}|awk -F'|' '{print $1}')" ]
	then
		END="$(echo ${array[$(($COUNT+1))]}|awk -F'|' '{print $2}'|sed 's/-//g')$(echo ${array[$(($COUNT+1))]}|awk -F'|' '{print $3}'|sed 's/://g')00"
	else
		END=$START
	fi

	#echo "Start = $START <> Ende = $END"

	# Programmeintrag in die XML Datei schreiben
	echo "<programme start=\"${START} +0100\" stop=\"${END} +0100\" channel=\"$(echo ${array[$COUNT]}|awk -F'|' '{print $1}')\">" >> $XML_FILE
	echo "  <title lang=\"de\">$(echo ${array[$COUNT]}|awk -F'|' '{printf $4}')</title>" >> $XML_FILE
	echo "  <desc>$(echo ${array[$COUNT]}|awk -F'|' '{printf $5 " - " $6}')</desc>" >> $XML_FILE
	echo "</programme>" >> $XML_FILE

	# nchster Eintrag
	COUNT=$(($COUNT+1))
done

# Footer in XML Datei schreiben
echo "</tv>" >> $XML_FILE

echo "Importiere XML Datei..."
$XMLTV2VDR -v -c $MODIFIED_CHANNELSCONF -x $XML_FILE

echo "...fertig"

